/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */

#include "config.h"
#include <stdio.h>

#include <Xm/DialogS.h>
#include <Xm/ScrolledW.h>
#include <Xm/DrawingA.h>
#include "xmap.h"
#include "debug.h"


extern Widget toplevel;

static Widget legenddialog = NULL;
static Widget draww;


static GC legendGC;
extern Pixmap legend;
static Dimension width, height;

static void redraw_cb()
{

    if (legend) {
	XtVaGetValues(draww, XmNwidth, &width, XmNheight, &height, NULL);
	XCopyArea(XtDisplay(draww), legend, XtWindow(draww), legendGC,
		  0, 0, width, height, 0, 0);
    }
}

void save_legend_properties()
{
	save_geometry(legenddialog, "legend");
}

void do_legend_dialog(Widget w, XtPointer client_data, XtPointer call_data)
{
    char bufp[256];
    Arg args[100];
    XmString s;
    int n;
    Position x, y;

    if (!legenddialog) {
	XGCValues gcv;
	int iw, ih;

	legenddialog = XtVaCreatePopupShell("legenddialog",
				xmDialogShellWidgetClass, GetTopShell(w),
					    XmNtitle, "Legend",		/* give arbitrary title in wm */
					    XmNminWidth, 60,
					    XmNmaxWidth, 190,
					    XmNminHeight, 30,
					    XmNmaxHeight, 350,
					    NULL);

	XtVaGetValues(toplevel,
		      XmNx, &x,
		      XmNy, &y,
		      NULL);

	y += 50;
	snprintf(bufp, 255, "%dx%d+%d+%d", 160, 300, x, y);
	GetPrivateProfileString("Layout", "legend", bufp, bufp, 255, inifile);

	XtVaSetValues(legenddialog, XmNgeometry, bufp, NULL);

	sscanf(bufp, "%dx%d", &iw, &ih);

	draww = XtVaCreateWidget("draw",
				 xmDrawingAreaWidgetClass, legenddialog,
				 XmNwidth, iw,
				 XmNheight, ih,
				 NULL);

	gcv.foreground = BlackPixelOfScreen(XtScreen(draww));
	legendGC = XCreateGC(XtDisplay(draww),
		RootWindowOfScreen(XtScreen(draww)), GCForeground, &gcv);

	XtAddCallback(draww, XmNexposeCallback, redraw_cb, NULL);

#if 0
	XtVaSetValues(legenddialog,
		      XmNx, x,
		      XmNy, y,
		      XmNwidth, width,
		      XmNheight, height,
		      NULL);
#endif
    }
    XtManageChild(draww);
    XtManageChild(legenddialog);
    XtPopup(legenddialog, XtGrabNone);
}
