/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */

#include "config.h"
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <varargs.h>
#include <netdb.h>
#include <stdio.h>
#include <errno.h>
#include "debug.h"


#ifndef INADDR_NONE
#define INADDR_NONE ((in_addr_t)-1)
#endif

static char mbuf[128];

u_short portbase = 0;

int connectTCP(char *host, char *service)
{
    struct hostent *phe;
    struct servent *pse;
    struct protoent *ppe;
    struct sockaddr_in sin;
    int s, type;

    bzero((char *) &sin, sizeof(sin));
    sin.sin_family = AF_INET;

    if (pse = getservbyname(service, "tcp"))
	sin.sin_port = htons(ntohs((u_short) pse->s_port) + portbase);
    else if ((sin.sin_port = htons((u_short) atoi(service))) == 0) {
	snprintf(mbuf, 127, "Can't get \"%s\" service entry.", service);
	errexit(mbuf, 0);
    }
    if (phe = gethostbyname(host))
	bcopy(phe->h_addr, (char *) &sin.sin_addr, phe->h_length);
    else if ((sin.sin_addr.s_addr = inet_addr(host)) == INADDR_NONE) {
	snprintf(mbuf, 127, "Unknown GPS host: \"%s\".\n", host);
	errexit(mbuf, 0);
    }
    if ((ppe = getprotobyname("tcp")) == 0) {
	errexit("Can't get tcp protocol entry.\nThis is very bad!", 0);
    }
    type = SOCK_STREAM;

    s = socket(PF_INET, type, ppe->p_proto);
    if (s < 0)
	errexit("Can't create socket", errno);

    if (connect(s, (struct sockaddr *) &sin, sizeof(sin)) < 0) {
	snprintf(mbuf, 127, "Can't connect to %s:%s", host, service);
	errexit(mbuf, errno);
    }
    return s;
}
